/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.domino.admin;


import com.funambol.server.config.Configuration;
import com.funambol.framework.tools.beans.BeanException;
import com.funambol.framework.tools.beans.BeanInstantiationException;
import com.funambol.framework.tools.beans.BeanInitializationException;
import com.funambol.framework.tools.beans.BeanNotFoundException;

import com.funambol.domino.exception.DominoConfigException;


/**
 * This class loads the parameter from the XML configuration file
 *
 * @version $Id: DominoConnectorConfig.java,v 1.1 2006/08/08 08:29:26 gibi Exp $
 */
public class DominoConnectorConfig {

    // --------------------------------------------------------------- CONSTANTS

    /**     */
    public final static String beanName = "dom/dom/FunambolDominoConnector.xml";

    // -------------------------------------------------------------- PROPERTIES

    /** backend server      */
    private String    host ;

    /** port                 */
    private int       port;

    /** ssl activation       */
    private boolean   ssl;

    /** datasource           */
    private String    dataSource;


    //------------------------------------------------------------- CONSTRUCTORS

    /**
     *
     */
    public DominoConnectorConfig () {
    }

    //----------------------------------------------------------- PUBLIC METHODS

   /**
    *
    * @return DominoConnectorConfig
    * @throws DominoConfigException
    */
   public static DominoConnectorConfig getConfigInstance()
        throws DominoConfigException {

       DominoConnectorConfig dominoConf = null;
       try {
          dominoConf = (DominoConnectorConfig)Configuration.getConfiguration().getBeanInstanceByName(beanName);
       } catch (BeanInstantiationException bie){
          throw new DominoConfigException(bie.getMessage());
       } catch (BeanInitializationException bie){
          throw new DominoConfigException(bie.getMessage());
       } catch (BeanNotFoundException bie){
          throw new DominoConfigException(bie.getMessage());
       } catch (BeanException be){
          throw new DominoConfigException(be.getMessage());
       }

       return dominoConf;

    }


    /**
     *
     *
     * @param host String
     */
    public void setHost(String host){
        this.host = host;
    }

    /**
     *
     *
     * @return host String
     */
    public String getHost(){
        return this.host;
    }


    /**
     *
     *
     * @param ssl boolean
     */
    public void setSsl(boolean ssl){
        this.ssl = ssl;
    }

    /**
     *
     *
     * @return ssl boolean
     */
    public boolean getSsl(){
        return this.ssl;
    }

    /**
     *
     *
     * @param port int
     */
    public void setPort(int port){
        this.port = port;
    }

    /**
     *
     *
     * @return port int
     */
    public int getPort(){
        return this.port;
    }

    /**
     *
     *
     * @param dataSource String
     */
    public void setDataSource(String dataSource){
        this.dataSource = dataSource;
    }

    /**
     *
     *
     * @return dataSource
     */
    public String getDataSource(){
        return this.dataSource;
    }

}
