/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */

package com.funambol.domino.engine.cache;

import com.funambol.framework.engine.SyncItemKey;
import java.sql.Timestamp;

/**
 *
 * @author Stefano Nichele
 * @version $Id: SyncItemInfo.java,v 1.1 2006/08/08 08:31:00 gibi Exp $
 */
public class SyncItemInfo {

    // -------------------------------------------------------------- Properties

    /**
     *
     */
    private Timestamp lastModified;


    /**
     *
     */
    private SyncItemKey key;


    /**
     *
     * @return Timestamp
     */
    public Timestamp getLastModified() {
        return lastModified;
    }

    /**
     *
     * @param lastModified Timestamp
     */
    public void setLastModified(Timestamp lastModified) {
        this.lastModified = lastModified;
    }

    /**
     *
     * @return SyncItemKey
     */
    public SyncItemKey getKey() {
        return key;
    }

    /**
     *
     * @param key SyncItemKey
     */
    public void setKey(SyncItemKey key) {
        this.key = key;
    }

    /**
     *
     * @param key String
     */
    public void setKey(String key) {
        this.key = new SyncItemKey(key);
    }

    // ------------------------------------------------------------ Constructors

    /**
     *
     */
    public SyncItemInfo() {
    }


    /**
     *
     * @param sKey String
     * @param lastModified Timestamp
     */
    public SyncItemInfo(String sKey, Timestamp lastModified) {
        SyncItemKey key = new SyncItemKey(sKey);
        this.key          = key;
        this.lastModified = lastModified;
    }

    /**
     *
     * @param key SyncItemKey
     * @param lastModified Timestamp
     */
    public SyncItemInfo(SyncItemKey key, Timestamp lastModified) {
        this.key          = key;
        this.lastModified = lastModified;
    }


}
