/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.domino.items.dao;

import java.util.logging.Level;

import com.funambol.domino.engine.cache.SyncItemInfo;

import lotus.domino.View;
import lotus.domino.Document;

import com.funambol.domino.exception.*;
import com.funambol.domino.util.*;
import java.util.ArrayList;
import lotus.domino.Database;
import lotus.domino.DocumentCollection;

/*
 * This class implements methods to access contacts data
 * in domino server datastore
 *
 * @@author Gilberto Migliavacca
 * @@version $Id: ContactDAO.java,v 1.1 2006/08/08 08:32:36 gibi Exp $
 *
 **/
public class ContactDAO extends EntityDAO {

    //------------------------------------------------------------- Costructors
    /**
     *
     */
    public ContactDAO(DominoWrapper dominoWrapper){
        super(dominoWrapper);
    }



    //------------------------------------------------------------- Public methods

    /**
     *
     * @return SyncItemInfo[]
     * @throws EntityException
     */
    public SyncItemInfo[] getAllSyncItemInfo(View view)
    throws EntityException{

        if (log.isLoggable(Level.FINEST)) {
            log.finest("ContactDAO start getAllSyncItemInfo");
        }

        ArrayList allSyncItemInfo = new ArrayList() ;
        SyncItemInfo syncItemInfo = null;
        try {
            
            Database db = wrapper.getDatabase();
            DocumentCollection contacts = db.search("Form =\"" + 
                                                  Def.CONTACT_FORM_NAME + "\"");
            
            Document doc = contacts.getFirstDocument();
            
            while (doc != null) {
                
                syncItemInfo = new SyncItemInfo();
                syncItemInfo.setLastModified(
                        Utility.dominoDateTimeToTimestamp(doc.getLastModified()));
                syncItemInfo.setKey(doc.getUniversalID());
                allSyncItemInfo.add(syncItemInfo);
                
                doc = contacts.getNextDocument(doc);
            }
            
        }catch (Exception e){
            throw new EntityException(e);
        }
        
        if (log.isLoggable(Level.FINEST)) {
            log.finest("ContactDAO end getAllSyncItemInfo");
        }
        
        return (SyncItemInfo[])allSyncItemInfo.toArray(new SyncItemInfo[0]);

    }

     //------------------------------------------------------------- Private methods

}