/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.domino.items.dao;

import com.funambol.domino.util.DominoWrapper;
import java.util.ArrayList;
import java.util.logging.Level;

import com.funambol.domino.engine.cache.SyncItemInfo;

import lotus.domino.View;
import lotus.domino.Document;

import com.funambol.domino.exception.*;
import com.funambol.domino.util.Def;
import com.funambol.domino.util.Utility;

/*
 * This class implements methods to access task data
 * in domino server datastore
 *
 * @@author Diogo Jesus
 * @@version $Id: TaskDAO.java,v 1.1 2006/08/08 08:32:37 gibi Exp $
 *
 **/
public class TaskDAO extends EntityDAO {


    //------------------------------------------------------------- Costructors
    /**
     *
     */
    public TaskDAO(DominoWrapper dominoWrapper){
        super(dominoWrapper);
    }


    //------------------------------------------------------------- Public methods
    /**
     *
     * @return SyncItemInfo[]
     * @throws EntityException
     */
    public SyncItemInfo[] getAllSyncItemInfo(View view) throws EntityException{

        if (log.isLoggable(Level.FINEST)) {
            log.finest("TaskDAO start getAllSyncItemInfo");
        }

        try {
            view.refresh();
        }catch (Exception e){
            throw new EntityException(e);
        }

        ArrayList allSyncItemInfo = new ArrayList() ;
        SyncItemInfo syncItemInfo = null;
        String form               = null;
        try {
            Document doc = view.getFirstDocument();

            while (doc != null) {

                form = doc.getItemValueString(Def.FORM);

                if (form.equalsIgnoreCase(Def.TODO_FORM_NAME)){
                   syncItemInfo = new SyncItemInfo();
                   syncItemInfo.setLastModified(
                       Utility.dominoDateTimeToTimestamp(doc.getLastModified()));
                   syncItemInfo.setKey(doc.getUniversalID());
                   allSyncItemInfo.add(syncItemInfo);
                }

                doc = view.getNextDocument(doc);
            }

        }catch (Exception e){
             throw new EntityException(e);
        }

        if (log.isLoggable(Level.FINEST)) {
            log.finest("TaskDAO end getAllSyncItemInfo");
        }

        return (SyncItemInfo[])allSyncItemInfo.toArray(new SyncItemInfo[0]);
    }


}
