/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.domino.items.manager ;


import java.util.Iterator;
import java.util.Vector;
import java.util.logging.*;

import com.funambol.domino.items.dao.EntityDAO;
import com.funambol.domino.util.*;
import com.funambol.domino.exception.*;
import com.funambol.framework.logging.Sync4jLogger;
import java.util.TimeZone;
import lotus.domino.Document;
import lotus.domino.NotesException;

/**
 *
 * @author Gilberto Migliavacca
 * @version $Id: EntityManager.java,v 1.1 2006/08/08 08:33:02 gibi Exp $
 */
public class EntityManager {
    
    
    // ------------------------------------------------------------ Private data
    
    
    // -------------------------------------------------------------- Properties
    
    /**
     *
     */
    public DominoWrapper dominoWrapper   = null;
    
    /**
     *
     */
    protected Logger  log = Sync4jLogger.getLogger(Def.LOGGER_NAME);
    
    /**
     * The timezone to use (if required) in the dates conversion
     */
    protected TimeZone timezone = null;
    /**
     *
     */
    public EntityDAO dao       = null;
    
    
    // ------------------------------------------------------------ Costructors
            
    //Domino Document categories
            
    public static final String CATEGORY_HOLIDAY     = "Holiday";
    public static final String CATEGORY_VACATION    = "Vacation";
    public static final String CATEGORY_PROJECTS    = "Projects";
    public static final String CATEGORY_CLIENTS     = "Clients";
    public static final String CATEGORY_PHONE_CALLS = "Phone Calls";
    public static final String CATEGORY_TRAVEL      = "Travel";
    
    public static final String HOLIDAY_CODE     = "H";
    public static final String VACATION_CODE    = "V";
    public static final String PROJECTS_CODE    = "P";
    public static final String CLIENTS_CODE     = "C";
    public static final String PHONE_CALLS_CODE = "PC";
    public static final String TRAVEL_CODE      = "T";
    
    
    
    // ---------------------------------------------------------- Public Methods
    
    /**
     * deletes an item
     *
     * @param UID String
     * @throws EntityException
     */
    public void removeItem(String UID) throws EntityException {
        
        dao.removeItem(UID,dominoWrapper);
        
    }
    
    
    /**
     * Clears all items on server
     * @param viewName String
     * @throws NotesException
     */
    public void removeAll(String viewName) throws EntityException {
        
        dao.removeAll(viewName, dominoWrapper);
        
    }
    
    /**
     * @param doc        Document
     * @param name       Item name
     * @param value      Item value
     * @throws NotesException
     */
    protected void setItemValue(Document doc, String name, Object value)
    throws NotesException {
        if(value != null) {
            if(doc.getItemValueString(name) != null)
                doc.replaceItemValue(name, value);
            else
                doc.appendItemValue(name, value);
        }
    }
    
    protected String getDocumentCategories(Document doc) throws NotesException {
        
        Vector categories = doc.getItemValue(Def.CATEGORIES);
        String formattedCategories = "";
        for (Iterator it = categories.iterator(); it.hasNext();) {
            
            String category = (String) it.next();
            
            if(category.equals(HOLIDAY_CODE))
                category = CATEGORY_HOLIDAY;
            else if(category.equals(VACATION_CODE))
                category = CATEGORY_VACATION;
            else if(category.equals(PROJECTS_CODE))
                category = CATEGORY_PROJECTS;
            else if(category.equals(CLIENTS_CODE))
                category = CATEGORY_CLIENTS;
            else if(category.equals(PHONE_CALLS_CODE))
                category = CATEGORY_PHONE_CALLS;
            else if(category.equals(TRAVEL_CODE))
                category = CATEGORY_TRAVEL;
            
            formattedCategories += category;
            
            if (it.hasNext())
                formattedCategories += ", ";
        }
        
        return formattedCategories;
    }
}
