/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */

package com.funambol.domino.util;

import com.funambol.domino.engine.cache.SyncItemInfo;
import com.funambol.domino.exception.EntityException;
import com.funambol.domino.items.model.ItemCalendar;
import com.funambol.foundation.pdi.event.Reminder;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.rmi.server.UID;
import java.util.Date;
import java.util.Iterator;

import java.util.Properties;
import java.util.Vector;

import lotus.domino.Database;
import lotus.domino.DbDirectory;
import lotus.domino.Document;
import lotus.domino.NotesException;
import lotus.domino.NotesFactory;
import lotus.domino.Session;
import lotus.domino.View;
import lotus.domino.DateTime;
import lotus.domino.DocumentCollection;
import lotus.domino.RichTextItem;

/*
 * This class implements methods to access domino server
 * datastore its main purpose is clear it.
 *
 * @version $Id: Test.java,v 1.1 2006/08/08 08:35:14 gibi Exp $
 *
 **/
public class Test {

    // --------------------------------------------------------------- Constants

    // Properties name
    private static final String CONFIGURATION_PROPERTIES_USER           = "user"         ;
    private static final String CONFIGURATION_PROPERTIES_PASSWORD       = "password"     ;
    private static final String CONFIGURATION_PROPERTIES_HOST           = "host"         ;
    private static final String CONFIGURATION_PROPERTIES_PORT           = "port"         ;

    // Default values
    private static final String DEFAULT_USER           = "fnbltest"      ;
    private static final String DEFAULT_PASSWORD       = "fnbltest"      ;
    private static final String DEFAULT_HOST           = "localhost"     ;
    private static final String DEFAULT_PORT           = "63148"         ;

    // name of the file used for store the information
    private static final String PROPERTIES_FILE_NAME   = "./server.ini";
    private static final String PROPERTIES_FILE_HEADER = "Domino Server properties";

    // ------------------------------------------------------------ Private data

    private Properties props = null;

    private Session  session    = null;
    private Database db         = null;
    private String   dbname     = null;
    private String   remoteuser = null;

    private String host     = DEFAULT_HOST;
    private String port     = DEFAULT_PORT;
    private String login    = DEFAULT_USER;
    private String password = DEFAULT_PASSWORD;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {

        Test client = new Test();
        client.testFormulas();
        client.documentsToXMLFiles();
//        client.removeCalendarItems();
//        client.clearDatabase();
//        try {
//            client.createDominoAllDayEvent();
//        } catch (EntityException ex) {
//            ex.printStackTrace();
//        }
        //client.insertNewAppointmentWithRepeats();


    }

    /** Creates a new instance of Client */
    public Test() {

        loadConfigurations();
        host   = getHostName();
        port     = getHostPort();
        login    = getUser();
        password = getPassword();
    }

    public void documentsToXMLFiles() {

        openConnection();
        try {


            ItemCalendar   test   = null;
            View           view   = db.getView(Def.CONTACT_VIEW);
            Document       doc    = view.getFirstDocument();
            String         form   = null;
            FileWriter     file   = null;
            BufferedWriter writer = null;

            for (int i = 0; doc != null; i++) {

                form = doc.getItemValueString(Def.FORM);

                if (form.equalsIgnoreCase(Def.CONTACT_FORM_NAME)){
                    try {

                        file   = new FileWriter("d:\\lab\\beans\\contacts\\" + doc.getItemValueString(Def.LAST_NAME) + i + ".xml");
                        writer = new BufferedWriter(file);
                        doc.generateXML(writer);
                        writer.close();
                        file.close();


                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }

                }

                doc = view.getNextDocument(doc);
            }

            DocumentCollection contacts = db.search("Form =\"Person\"");

            Document contact = contacts.getFirstDocument();

            for (int i = 0; contact != null; i++) {

                try {

                    file   = new FileWriter("d:\\lab\\beans\\contacts\\test-" + contact.getItemValueString(Def.LAST_NAME) + i + ".xml");
                    writer = new BufferedWriter(file);
                    contact.generateXML(writer);
                    writer.close();
                    file.close();


                } catch (IOException ex) {
                    ex.printStackTrace();
                }
                contact = contacts.getNextDocument();
            }

            view   = db.getView(Def.CALENDAR_VIEW);
            doc    = view.getFirstDocument();
            int i = 0;
            while (doc != null) {
                i++;
                form = doc.getItemValueString(Def.FORM);

                if (form.equalsIgnoreCase(Def.CALENDAR_FORM_NAME)){
                    try {

//                        Vector items = doc.getItems();
//                        String aux = items.toString();
//                        File f = new File("d:\\lab\\beans\\appointments\\" + doc.getItemValueString(Def.SUBJECT) + ".properties");
//                        FileOutputStream fos = new FileOutputStream(f);
//                        fos.write(aux.getBytes());
//                        fos.close();

                        file   = new FileWriter("d:\\lab\\beans\\appointments\\" + doc.getItemValueString(Def.SUBJECT) + i + ".xml");
                        writer = new BufferedWriter(file);
                        doc.generateXML(writer);
                        writer.close();
                        file.close();


                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }

                }

                doc = view.getNextDocument(doc);
            }


            view   = db.getView(Def.TODO_VIEW);
            doc    = view.getFirstDocument();
            i = 0;
            while (doc != null) {
                i++;
                form = doc.getItemValueString(Def.FORM);

                if (form.equalsIgnoreCase(Def.TODO_FORM_NAME)){
                    try {

                        file   = new FileWriter("d:\\lab\\beans\\tasks\\" + doc.getItemValueString(Def.SUBJECT) + i + ".xml");
                        writer = new BufferedWriter(file);
                        doc.generateXML(writer);
                        writer.close();
                        file.close();


                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }

                }

                doc = view.getNextDocument(doc);
            }


        } catch (NotesException ex) {
            ex.printStackTrace();
        }




        releaseConnection();
    }


    public void clearDatabase() {
        openConnection();

        try {

            View contacts = db.getView(Def.CONTACT_VIEW);
            clearView(contacts);

            View calendar = db.getView(Def.CALENDAR_VIEW);
            clearView(calendar);

        } catch (NotesException ex) {
            ex.printStackTrace();
        }
        releaseConnection();
    }



    public void openConnection() {

        openConnection(host, Integer.parseInt(port) , login, password);
    }
    /**
     *
     * @param host String
     * @param login String
     * @param password String
     * @return Session
     */
    public void openConnection(String host,
            int port,
            String login,
            String password) {

        System.out.println("Starting connection process...");

        try {
            String ior = NotesFactory.getIOR(host+":"+port);
            System.out.println(" ior " + ior);
            session = NotesFactory.createSessionWithIOR(ior,login,password);

            remoteuser = session.getUserName();

            login = session.getCommonUserName();

            DbDirectory dbd = session.getDbDirectory(host);
            db = dbd.openMailDatabase();

            dbname =  db.getFilePath();

            System.out.println("remote session name = " + remoteuser);
            System.out.println("login               = " + login);
            System.out.println("Title of database   = " + dbname);

        } catch (Exception e) {
            e.printStackTrace() ;
        }
    }



    /**
     * chiude le connessioni
     *
     */
    public void releaseConnection() {
        try {
            db.recycle();
            session.recycle();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public void clearView(View view) throws NotesException {

        view.refresh();
        view.getAllEntries().removeAll(true);

    }

    public void testFormulas() {
        openConnection();
        try {

            DocumentCollection view = db.search("Form =\"Appointment\" & " +
                "($CSFlags=\"i\" | $CSFlags=LEI | Repeats!=\"1\") & "      +
                Def.SUBJECT + " = \"pq\" & " +
                Def.LOCATION + " = \"pq\" & " +
                Def.START_DATE_TIME + " = [08-23-2006 08:00:00 AM GDT] & " +
                Def.END_DATE_TIME + " = [08-23-2006 08:31:00 AM GDT]");

            int count = view.getCount();
            System.out.println("Count = " + count);


        } catch (NotesException ex) {
            ex.printStackTrace();
        }
        releaseConnection();
    }


    public void removeCalendarItems() {
        openConnection();
        try {

            DocumentCollection view = db.search("Form =\"Appointment\" & " +
                    "($CSFlags=\"i\" | $CSFlags=LEI | Repeats!=\"1\")");

            int count = view.getCount();
            Document doc = view.getFirstDocument();

            while (doc != null) {

                if(doc.isResponse()) {

                    Document parent = db.getDocumentByUNID(doc.getParentDocumentUNID());
                    DocumentCollection responses = parent.getResponses();
                    Document response = responses.getDocument(doc);
                    response.remove(true);

                    int responsesCount = responses.getCount();
                    if(responses.getCount() < 1)
                        parent.remove(true);

                } else {
                    doc.remove(true);
                }
                doc = view.getNextDocument();
            }

        } catch (NotesException ex) {
            ex.printStackTrace();
        }
        releaseConnection();
    }


    /**
     * Load properties
     */
    public void loadConfigurations() {
        props = new Properties();
        try {
            props.load(new FileInputStream(PROPERTIES_FILE_NAME));
        } catch (IOException ex) {
            System.out.println("Error while trying to read configuration properties");
        }

    }

    /**
     * Save properties
     */
    public void saveConfigurations() {
        Properties propsToSave = new Properties();
        propsToSave.putAll(props);

        try {
            propsToSave.store(new FileOutputStream(PROPERTIES_FILE_NAME),
                    PROPERTIES_FILE_HEADER);
        } catch (IOException e) {
            System.out.println("Error while trying to save configuration properties");
        }

    }

    /** Returns user */
    public String getUser() {
        return props.getProperty(this.CONFIGURATION_PROPERTIES_USER, DEFAULT_USER);
    }

    /**
     * Set user
     * @param user to set
     */
    public void setUser(String user) {
        props.setProperty(this.CONFIGURATION_PROPERTIES_USER, user);
    }

    /** Returns password */
    public String getPassword() {
        return props.getProperty(this.CONFIGURATION_PROPERTIES_PASSWORD, DEFAULT_PASSWORD);
    }

    /**
     * Set password
     * @param password to set
     */
    public void setPassword(String password) {
        props.setProperty(this.CONFIGURATION_PROPERTIES_PASSWORD, password);
    }

    /** Returns hostName */
    public String getHostName() {
        return props.getProperty(this.CONFIGURATION_PROPERTIES_HOST, DEFAULT_HOST);
    }

    /**
     * Set hostName
     * @param hostName to set
     */
    public void setHostName(String hostName) {
        props.setProperty(this.CONFIGURATION_PROPERTIES_HOST, hostName);
    }

    /** Returns hostPort */
    public String getHostPort() {
        return props.getProperty(this.CONFIGURATION_PROPERTIES_PORT, DEFAULT_PORT);
    }

    /**
     * Set hostPort
     * @param hostPort to set
     */
    public void setHostPort(final String hostPort) {
        props.setProperty(CONFIGURATION_PROPERTIES_PORT, hostPort);
    }

    /**
     * converts Domino calendar in Foundation Calendar
     *
     * @param dominoDoc Document
     * @param itemFormat String
     *
     * @return ItemCalendar
     *
     */
    public ItemCalendar createFoundationEvent(Document dominoDoc, String itemFormat) throws EntityException {


        // get values from Domino Document
        String dominoCalendarType = null;
        String clientCalendarType = null;
        String subject            = null;
        String body               = null;
        String location           = null;
        String start              = null;
        DateTime startDomino      = null;
        String end                = null;
        DateTime endDomino        = null;
        String dominoAlarm        = null;
        String clientAlarm        = null;
        double dominoOffset       ;
        String dominoOffsetUnit   = null;
        String clientOffset       = null;
        String dominoConfidential = null;
        String clientConfidential = null;

        // get info from Domino Document
        try {

            dominoCalendarType = dominoDoc.getItemValueString(Def.APPOINTMENT_TYPE) ;

            clientCalendarType = UtilityCalendar.setClientCalendarType(
                    dominoCalendarType,
                    itemFormat);

            subject  = dominoDoc.getItemValueString(Def.SUBJECT);
            body     = dominoDoc.getItemValueString(Def.BODY);
            location = dominoDoc.getItemValueString(Def.LOCATION);


            if (dominoCalendarType.equalsIgnoreCase("2")){
                // if all day event
                startDomino = Utility.getDominoDateTime(dominoDoc,Def.START_DATE_TIME);
                start       = Utility.setAllDayClient_StartDate(startDomino);

                //endDomino = Utility.getDominoDateTime(dominoDoc,Def.END_DATE_TIME);
                end = Utility.setAllDayClient_StartDate(startDomino);

            } else {
                //otherwise
                startDomino = Utility.getDominoDateTime(dominoDoc,Def.START_DATE_TIME);
                start = Utility.setClientDateTime(startDomino);

                endDomino = Utility.getDominoDateTime(dominoDoc,Def.END_DATE_TIME);
                end = Utility.setClientDateTime(endDomino);
            }


            // alarm
            dominoAlarm  = dominoDoc.getItemValueString(Def.ALARMS);
            //  clientAlarm  = UtilityCalendar.setClientAlarm(dominoAlarm, itemFormat);

            dominoOffset     = dominoDoc.getItemValueDouble(Def.ALARM_OFFSET);
            dominoOffsetUnit = dominoDoc.getItemValueString(Def.ALARMS_UNIT);
            //clientOffset = UtilityCalendar.calcClientAlarmOffset(dominoOffset,
            //        dominoOffsetUnit, null, null, itemFormat);


            // confidential
            dominoConfidential = dominoDoc.getItemValueString(Def.ORG_CONFIDENTIAL);
            clientConfidential = Utility.setClientConfidential(dominoConfidential,
                    itemFormat);


        }catch (Exception e) {
            throw new EntityException(e);
        }

        // create a new foundation calendar
        ItemCalendar ctmp = new ItemCalendar();

        // set UID
        String uid = "";
        try{
            uid = dominoDoc.getUniversalID();
        } catch (Exception e) {
            throw new EntityException(e);
        }
        ctmp.setId(uid);


        ctmp.getEvent().getSummary().setPropertyValue(subject);
        ctmp.getEvent().getDescription().setPropertyValue(body);
        ctmp.getEvent().getLocation().setPropertyValue(location);

        ctmp.getEvent().getDtStart().setPropertyValue(start);

        if (dominoCalendarType.equalsIgnoreCase("2")){
            // do nothing
        } else {
            ctmp.getEvent().getDtEnd().setPropertyValue(end);
        }


        if (clientAlarm != null){
            if (itemFormat.equals(Def.ICAL_TYPE)){
                if (clientAlarm.equalsIgnoreCase("true")){
                    // set the AALARM field
                    // 20050210T074500;;0;CalenAlarmSound
                    ctmp.getEvent().getReminder().setPropertyValue(clientOffset+";;0;CalenAlarmSound");
                } else {
                    // no AALARM field
                }
            } else {
                ctmp.getEvent().setReminder(new Reminder());
                if (clientAlarm.equalsIgnoreCase("true")){
                    ctmp.getEvent().getReminder().setActive(true);
                    int m = Integer.parseInt(clientOffset);
                    ctmp.getEvent().getReminder().setMinutes(m);
                } else {
                    ctmp.getEvent().getReminder().setActive(false);
                    ctmp.getEvent().getReminder().setMinutes(0);
                }
            }
        }

        // confidential
        if (clientConfidential != null ){
            ctmp.getEvent().getClassEvent().setPropertyValue(clientConfidential);
        }

        // calendar type
        if (itemFormat.equals(Def.ICAL_TYPE)) {
            ctmp.addXTag(UtilityCalendar.setXTagForCalendar(clientCalendarType));
        } else {
            if (clientCalendarType.equals("ALLDAY")){
                ctmp.getEvent().setAllDay(new Boolean(true));
            } else {
                /**
                 * @todo calendar type
                 */
            }
        }


        return ctmp;

    }

    public void insertNewAppointmentWithRepeats() {
        openConnection();
        try {
            Document doc = db.createDocument();

            // Creating dates vectors----------------------------------------------
            Session stmp = db.getParent();
            DateTime currTime = stmp.createDateTime(new Date());
            currTime.setNow();
            Vector startDateVector = new Vector();
            DateTime dti1 = stmp.createDateTime(currTime.getLocalTime());
            startDateVector.addElement(dti1); // first day
            currTime.adjustDay(7,true);
            DateTime dti2 = stmp.createDateTime(currTime.getLocalTime());
            startDateVector.addElement(dti2); // second day
            currTime.adjustDay(7,true);
            DateTime dti3 = stmp.createDateTime(currTime.getLocalTime());
            startDateVector.addElement(dti3); // third day

            currTime.adjustDay(-14,true);
            // set and time
            currTime.adjustHour(1, true);
            // set three days with the same end time
            Vector endDateVect = new Vector();
            DateTime dtf1 = stmp.createDateTime(currTime.getLocalTime());
            endDateVect.addElement(dtf1); // first day
            currTime.adjustDay(7,true);
            DateTime dtf2 = stmp.createDateTime(currTime.getLocalTime());
            endDateVect.addElement(dtf2); // second day
            currTime.adjustDay(7,true);
            DateTime dtf3 = stmp.createDateTime(currTime.getLocalTime());
            endDateVect.addElement(dtf3); // third day
            // --------------------------------------------------------------------

            // parent's and child's fields
            doc.appendItemValue("Form","Appointment");
            doc.appendItemValue("Subject","mio appuntamento");
            doc.appendItemValue("Location","lacazione");
            doc.appendItemValue("h_AttachmentNamesAlt","QPNULL");
            doc.appendItemValue("h_AttachmentLengthsAlt","QPNULL");
            doc.appendItemValue("$Alarm",0);
            doc.appendItemValue("AppointmentType","0");
            doc.appendItemValue("$PublicAccess","1");
            doc.appendItemValue("$BusyPriority","1");
            doc.appendItemValue("$PreventReplies","0");
            doc.appendItemValue("From",this.remoteuser);
            doc.appendItemValue("ApptUNID", doc.getUniversalID());
            doc.appendItemValue("Principal",this.remoteuser);
            Vector excludeFromViewVector = new Vector();
            excludeFromViewVector.addElement("D");
            excludeFromViewVector.addElement("S");
            doc.appendItemValue("ExcludeFromView",excludeFromViewVector);
            doc.appendItemValue("SequenceNum",1);
            doc.appendItemValue("UpdateSeq",1);
            Vector cswislVect = new Vector();
            cswislVect.add("$S:1");
            cswislVect.add("$L:1");
            cswislVect.add("$B:1");
            cswislVect.add("$R:1");
            cswislVect.add("$E:1");
            doc.appendItemValue("$CSWISL", cswislVect);
            doc.appendItemValue("$CSVersion","2");
            //doc.appendItemValue("txtNum","3");
            doc.appendItemValue("OrgTable","C0");
            doc.appendItemValue("_ViewIcon", 160);
            doc.appendItemValue("Body", "body");
            doc.appendItemValue("Repeats","1");
            doc.appendItemValue("OrgRepeat","1");

            doc.appendItemValue("StartDate",startDateVector.get(0));
            doc.appendItemValue("StartTime",startDateVector.get(0));
            doc.appendItemValue("EndDate",startDateVector.get(0));
            doc.appendItemValue("EndTime",endDateVect.get(0));
            doc.appendItemValue("RepeatInstanceDates", startDateVector);
            //  doc.appendItemValue("$NoPurge", endDateVect.lastElement());

            // Creating parent and child
            Document parentDoc = doc;
            Document childDoc = db.createDocument();
            doc.copyAllItems(childDoc, false);

            // Only parent's fields --------------------------------------------------
            parentDoc.appendItemValue("RepeatCustom","");
            parentDoc.appendItemValue("RepeatWeekends","D");
            parentDoc.appendItemValue("RepeatUnit","W");
            parentDoc.appendItemValue("RepeatInterval","1");
            parentDoc.appendItemValue("RepeatAdjust","3");
            parentDoc.appendItemValue("RepeatHow","F");
            parentDoc.appendItemValue("RepeatFor", 3);
            parentDoc.appendItemValue("RepeatForUnit","W");
            parentDoc.appendItemValue("$CSFlags","c");

            parentDoc.appendItemValue("RepeatStartDate",startDateVector.get(0));
            parentDoc.appendItemValue("RepeatUntil", startDateVector.lastElement());
            parentDoc.appendItemValue("STARTDATETIME",startDateVector.get(0));
            parentDoc.appendItemValue("EndDateTime",endDateVect.get(0));
            parentDoc.appendItemValue("RepeatDates",startDateVector);
            parentDoc.appendItemValue("RepeatEndDates", endDateVect);

            parentDoc.computeWithForm(true, false);
            parentDoc.save(true, true, true);


            // Child's fields ------------------------------------------------------
            childDoc.appendItemValue("Chair", this.remoteuser);
            childDoc.appendItemValue("AltChair", this.remoteuser);
            childDoc.appendItemValue("$AltPrincipal", this.remoteuser);
            childDoc.appendItemValue("$REF", parentDoc.getUniversalID());
            childDoc.appendItemValue("$RefOptions","1");
            childDoc.appendItemValue("$CSFlags","i");

            childDoc.appendItemValue("STARTDATETIME", startDateVector);
            childDoc.appendItemValue("CalendarDateTime", startDateVector);
            childDoc.appendItemValue("EndDateTime",endDateVect);

            childDoc.makeResponse(parentDoc);
            // N.B. don't use computeWithForm in child document!
            childDoc.save(true, true, true);

        } catch (NotesException e) {
            e.printStackTrace();
        }
        releaseConnection();
    }

    public void createDominoAllDayEvent()
    throws EntityException {


        openConnection();
        // create a Domino alldayenvet
        try {
            Document doc = null;

            String subject  = "subject";
            String body     = "body";
            String location = "location";

            // for all day the date format is yyyy-mm-dd
            Date start = new Date();
            DateTime startDateTime = db.getParent().createDateTime(new Date());
            DateTime startDate     = db.getParent().createDateTime(start);
            DateTime startTime     = db.getParent().createDateTime(start);
            DateTime endDateTime   = db.getParent().createDateTime(start);
            DateTime endDate       = db.getParent().createDateTime(start);
            DateTime endTime       = db.getParent().createDateTime(start);

            // confidential
            // sensitity tag for SIF-XML e CLASS for ICAL
            String dominoConfidential = "1";

            String categories = "categories";


            doc = db.createDocument();

            doc.appendItemValue(Def.FORM,  Def.CALENDAR_FORM_NAME) ;
            doc.appendItemValue(Def.APPOINTMENT_TYPE, "2") ;

            doc.appendItemValue(Def.PRINCIPAL, "fnbltest") ;
            doc.appendItemValue(Def.FROM, "fnbltest") ;
            doc.appendItemValue(Def.CHAIR, "fnbltest") ;

            doc.appendItemValue(Def.VIEW_ICON,        new Integer(9)) ;

            doc.appendItemValue(Def.PUBLIC_ACCESS,    "1") ;
            doc.appendItemValue(Def.ORG_TABLE,        "P0") ;
            doc.appendItemValue(Def.EXCLUDE_FROM_VIEW,"D") ;
            doc.appendItemValue(Def.SEQUENCE_NUM,     new Integer(1)) ;

            doc.appendItemValue(Def.SUBJECT,  subject) ;
            doc.appendItemValue(Def.LOCATION, location) ;
            RichTextItem rti = doc.createRichTextItem(Def.BODY);
            rti.appendText(body);

            // date fields
            doc.appendItemValue(Def.CALENDAR_DATE_TIME, startDateTime) ;
            doc.appendItemValue(Def.NO_PURGE          , endDateTime) ;

            doc.appendItemValue(Def.START_DATE,      startDate) ;
            doc.appendItemValue(Def.START_TIME,      startTime) ;
            doc.appendItemValue(Def.START_DATE_TIME, startDateTime) ;

            doc.appendItemValue(Def.END_DATE,        endDate) ;
            doc.appendItemValue(Def.END_TIME,        endTime) ;
            doc.appendItemValue(Def.END_DATE_TIME,   endDateTime) ;

            doc.appendItemValue("AppendStartTime",   startTime);
            doc.appendItemValue("AppendEndTime"  ,   endTime);

            // reuired in iNotes6
            doc.appendItemValue("ApptUNID",doc.getUniversalID()) ;

            doc.save(true, true, true);

            releaseConnection();
        }catch (Exception e){
            throw new EntityException(e.toString() );
        }

    }

}

